
#include "string_transport_protocoll.h"
#include <stdlib.h> 	/*  atoi(), free()  */
#include <stdio.h>  	/*  printf()  */
#include <pthread.h>	/*  pthread_create() and pthread_exit()*/
#define PANIC(msg) {perror(msg);exit(0);}

#define MAX_CHILDREN 20

int number=0;
int used_child[MAX_CHILDREN];

pthread_attr_t child_attr[MAX_CHILDREN];
pthread_t child[MAX_CHILDREN];

void* echo_client(void* v)
{
	int alive=1;
	char* c;
	stp_connection s;
	s = (stp_connection)v;
    while(alive)
    {
		c=stp_recv(s);
		if (c){
			printf("received: %s \n",c);
			alive = !stp_send(s,c);
			free(c);
		}else
			alive=0;
    }
    stp_shutdown(s);
    fflush(stdout);
    printf("echo_client ended\n");
    pthread_exit(NULL);
    return v;
}

void callback(stp_connection s){
	pthread_attr_init(&child_attr[number]);
	used_child[number]=1;
	if ( pthread_create(&child[number], &child_attr[number], echo_client, s) != 0 )PANIC("pthread_create");
	number++;
	printf("callback ended\n");
}

int main(int argc, char** argv){
	int i;
	int port;
	stp_accepter a;
	
	if(argc>1)
		port = atoi(argv[1]);
	else
		port = 9999;
	
	for(i=0;i<MAX_CHILDREN;i++){
		used_child[i]=0;
	}
	
	a = stp_accept_connections(port, &callback);
	
	sleep(20);
	
	stp_stop_accepting(a);
	
	for(i=0;i<MAX_CHILDREN;i++){
		if(used_child[i]){
			pthread_join( child[i], 0 );
			pthread_attr_destroy( &child_attr[i] );
			pthread_detach( child[i] );
		}
	}
	
	printf("main ended\n");fflush(stdout);
	return 0;
}
